var ProductAPI = require('./lib/ProductAPI'),
    CMSAPI = require('./lib/CMSAPI'),
    CMSLoader = require('./lib/CMSLoader')

module.exports = function(defaults) { 
    if(defaults.service == null || defaults.service === 'undefined') throw('default.services is undefined');
    if(defaults.apikey == null || defaults.apikey === 'undefined') throw('default.apikey is undefined');
    var LSDefaults = {
        apikey: defaults.apikey
    }

    var model = {
        ProductAPI: function(defaults) {
            return ProductAPI({
                apikey: LSDefaults.apikey
            })
        },
        CMSAPI: function() {
            return CMSAPI({
                apikey: LSDefaults.apikey
            })
        },
        CMSLoader: function() {
            return CMSLoader()
        },
    }
    
    switch(defaults.service) {
        case 'productapi': 
            return model.ProductAPI;
        case 'cmsapi':
            return model.CMSAPI;
        case 'cmsloader':
            return model.CMSLoader;
        default: return {};
    }
}
