var options = require('./options'),
    request = require('request')

module.exports = function(defaults) {

    let load = function(section) {
        return new Promise(function(fulfill, reject) {
            const URL = options.server.base + options.server.CMSRequestURL + '/' + section
            console.log(URL)
            
            request.get({
                headers: {
                    'Content-Type' : 'application/x-www-form-urlencoded',
                    'Authorization': 'Bearer ' + defaults.apikey
                },
                url: URL
            },
            (err, res, body) => {
                if(err || err != null) reject({error: true, message: 'Can not connect to http://node.letsnet.hu server ...'})
                else {
                    fulfill(body)
                }
            });
        })
    }

    var model = {}

    model.load = function(section, callback) {
        load(section)
        .then(function(body) {
            callback(null, body)
        })
        .catch(function(err) {
            callback(err, null)
        })
    }

    return model
}