var fs = require('fs'),
    options = require('./options'),
    js2xml = require('js2xmlparser')

module.exports = function(section) {

    var cmsBase = require(options.__elementsDir + section + '/data'),
        htmlBase = js2xml.parse('cms', cmsBase),
        replaceElements = [],
        elementStyle = "",
        elementScript = ""

    let CMSFileLoader = {
        scriptFile: "script.js",
        styleFile: "style.css",
        script: "script",
        style: "style",
        scriptLoader: function(sect) {
            let file = __dirname.substr(0, __dirname.length - 3) + 'elements/' + sect + '/' + this.scriptFile
            if(fs.existsSync(file)) {
                return '<script type="text/javascript" from="element">' + fs.readFileSync(file, 'utf-8') + '</script>'
            }
        },
        styleLoader: function(sect) {
            let file = __dirname.substr(0, __dirname.length - 3) + 'elements/' + sect + '/' + this.styleFile
            if(fs.existsSync(file)) {
                return '<style type="text/css" from="element">' + fs.readFileSync(file, 'utf-8') + '</style>'
            }
        }
    }

    let findElements = function(obj) {
        if(typeof obj == 'object') {
            for(s in obj) {
                if(s == 'element') {
                    replaceElements.push(obj[s])
                    return obj[s]
                }
                else if(s == '@' || s == '#') {
                    continue
                }
                else if(typeof obj[s] === 'object') {
                    findElements(obj[s])
                }
            }
        }
        else {
            return obj
        }
    }

    function init() {
        findElements(cmsBase)
    }

    init()

    var model = {}

    /* properties */

    model.cmsBase = cmsBase
    model.htmlBase = htmlBase.substr(22)
    model.replaceElements = replaceElements
    model.scriptFile = CMSFileLoader.scriptLoader(section)
    model.styleFile = CMSFileLoader.styleLoader(section)

    /* functions */

    model.html = function() {
        return js2xml.parse('cms', model.cmsBase).substr(22)
    }

    return model
}