var request = require('request')
    options = require('./options'),
    ProdAPIRequestURL = options.server.base + options.server.ProdAPIRequestURL

module.exports = function(defaults) {

    let getCategories = function() {
        return new Promise((fulfill, reject) => {
            request.get({
                headers: {
                    'Content-Type' : 'application/json',
                    'Authorization': 'Bearer ' + defaults.apikey
                },
                url: ProdAPIRequestURL + '/getCategories'
            },
            (err, res, body) => {
                if(err || err != null) reject({error: true, message: 'Can not connect to http://node.letsnet.hu server ...'})
                else {
                    response = JSON.parse(body)
                    if(response.err = true) reject(response)
                    else fulfill(response)
                }
            });
        })
    }

    let getProductsByCategoryName = function(categoryname, start, end) {
        return new Promise((fulfill, reject) => {
            request.get({
                headers: {
                    'Content-Type' : 'application/json',
                    'Authorization': 'Bearer ' + defaults.apikey
                },
                url: ProdAPIRequestURL + '/getCategoryProducts/' + categoryname + '/' + start + '/' + end
            },
            (err, res, body) => {
                if(err || err != null) reject({error: true, message: 'Can not connect to http://node.letsnet.hu server ...'})
                else {
                    response = JSON.parse(body)
                    if(response.err = true) reject(response)
                    else fulfill(response)
                }
            });
        })
    }

    let getProductsByCategoryID = function(categoryid, start, end) {
        return new Promise((fulfill, reject) => {
            request.get({
                headers: {
                    'Content-Type' : 'application/json',
                    'Authorization': 'Bearer ' + defaults.apikey
                },
                url: ProdAPIRequestURL + '/getCategoryProducts/' + categoryid + '/' + start + '/' + end
            },
            (err, res, body) => {
                if(err || err != null) reject({error: true, message: 'Can not connect to http://node.letsnet.hu server ...'})
                else {
                    response = JSON.parse(body)
                    if(response.err = true) reject(response)
                    else fulfill(response)
                }
            });
        })
    }

    let getCategoryProperties = function(categoryid) {
        return new Promise((fulfill, reject) => {
            request.get({
                headers: {
                    'Content-Type' : 'application/json',
                    'Authorization': 'Bearer ' + defaults.apikey
                },
                url: ProdAPIRequestURL + '/getCategoryProperties/' + categoryid
            },
            (err, res, body) => {
                if(err || err != null) reject({error: true, message: 'Can not connect to http://node.letsnet.hu server ...'})
                else {
                    response = JSON.parse(body)
                    if(response.err = true) reject(response)
                    else fulfill(response)
                }
            });
        })
    }

    let getProductInfo = function(prodid) {
        return new Promise((fulfill, reject) => {
            request.get({
                headers: {
                    'Content-Type' : 'application/json',
                    'Authorization': 'Bearer ' + defaults.apikey
                },
                url: ProdAPIRequestURL + '/getProductInfo/' + prodid
            },
            (err, res, body) => {
                if(err || err != null) reject({error: true, message: 'Can not connect to http://node.letsnet.hu server ...'})
                else {
                    response = JSON.parse(body)
                    if(response.err = true) reject(response)
                    else fulfill(response)
                }
            });
        })
    }

    var model = {}

    model.getCategories = function(callback) {
        getCategories()
        .then(function(categories) {
            callback(null, categories)
        })
        .catch(function(err) {
            callback(err, null)
        })
    }

    model.getProductsByCategoryName = function(callback) {
        getProductsByCategoryName()
        .then(function(products) {
            callback(null, products)
        })
        .catch(function(err) {
            callback(err, null)
        })
    }

    model.getProductsByCategoryID = function(categoryid, start, end, callback) {
        getProductsByCategoryID(categoryid, start, end)
        .then(function(products) {
            callback(null, products)
        })
        .catch(function(err) {
            callback(err, null)
        })
    }

    model.getCategoryProperties = function(categoryid, callback) {
        getCategoryProperties(categoryid)
        .then(function(properties) {
            callback(null, properties)
        })
        .catch(function(err) {
            callback(err, null)
        })
    }

    model.getProductInfo = function(prodid, callback) {
        getProductInfo(prodid)
        .then(function(product) {
            callback(null, product)
        })
        .catch(function(err) {
            callback(err, null)
        })
    }

    return model
}